#include <conio.h>
#include <stdio.h>

#ifdef CPM
#include "cpm.c"
#endif

#ifdef SOS
#include "sos.c"
#endif

#ifdef _MSC_BUILD
#include "win.c"
#endif

#define	MAP_WIDTH	31
#define	MAP_HEIGHT	21

int		mEat = 0;
int		mFoodX, mFoodY;
int		mScore = 0;
char	mVSX[ MAP_HEIGHT ][ MAP_WIDTH ];
char	mVSY[ MAP_HEIGHT ][ MAP_WIDTH ];

char addFood()
{
	char	x = rand() % ( MAP_WIDTH  / 2 ) * 2 + 1;
	char	y = rand() % ( MAP_HEIGHT / 2 ) * 2 + 1;
	mFoodX = x;
	mFoodY = y;

	while( mVSX[ mFoodY ][ mFoodX ] ||
	       mVSY[ mFoodY ][ mFoodX ] ){
		mFoodX += 2;
		if( x == mFoodX && y == mFoodY ){
			locate( 10, 11 );
			printf( " GAME CLEAR! " );
			return( 1 );
		}
		if( mFoodX < MAP_WIDTH ){
			continue;
		}
		mFoodX = 1;
		mFoodY += 2;
		if( mFoodY >= MAP_HEIGHT ){
			mFoodY = 1;
		}
	}

	mEat = 1;

	locate( 6, 0 );
	printf( "%3d", mScore++ );
	locate( mFoodX, mFoodY + 1 );
	putchar( '$' );

	return( 0 );
}

void main()
{
#ifdef CPM
	printf( "\033x5" );
#endif

#ifdef SOS
	width( 40 );
#endif

	cls();

	locate( 14, 12 );
	printf( "PUSH ANY KEY\n" );
	int		s = 0;
	while( !kbhit() ){
		s++;
	}
	getch();
	srand( s );

	int		px = MAP_WIDTH / 4 * 2 - 1, py = MAP_HEIGHT / 4 * 2 + 1;
	int		lx = px, ly = py;
	int		ax = 1, ay = 0;
	int		dx = 1, dy = 0;
	int		time = 0;
	memset( mVSX, 0x00, MAP_HEIGHT * MAP_WIDTH );
	memset( mVSY, 0x00, MAP_HEIGHT * MAP_WIDTH );
	mVSX[ py ][ px ] = 1;

	cls();

	addFood();

	for( int y = 1; y <= MAP_HEIGHT; y++ ){
		locate( 0, y );
		putchar( '#' );
		locate( MAP_WIDTH - 1, y );
		putchar( '#' );
	}
	for( int x = 1; x < MAP_WIDTH - 1; x++ ){
		locate( x, 1 );
		putchar( '#' );
		locate( x, MAP_HEIGHT );
		putchar( '#' );
	}

	locate( 0, 0 );
	printf( "SCORE" );
	locate( 12, 0 );
	printf( "TIME" );

	while( 1 ){
		msleep( 100 );

		if( kbhit() ){
			int		ch = getch();
			if( ch == 0x32 ){	dx =  0;	dy =  1;	}
			if( ch == 0x34 ){	dx = -1;	dy =  0;	}
			if( ch == 0x36 ){	dx =  1;	dy =  0;	}
			if( ch == 0x38 ){	dx =  0;	dy = -1;	}
		}

		locate( 16, 0 );
		printf( "%4d", time++ );

//		if( px % 2 != 0 && py % 2 != 0 ){
		if( ( px & 1 ) != 0 && ( py & 1 ) != 0 ){
			ax = dx;
			ay = dy;
		}

		mVSX[ py ][ px ] = ax;
		mVSY[ py ][ px ] = ay;

		px += ax;
		py += ay;

		if( mVSX[ py ][ px ] ||
		    mVSY[ py ][ px ] ||
		    px == 0 || px == MAP_WIDTH  - 1 ||
		    py == 0 || py == MAP_HEIGHT - 1 ){
			locate( px, py + 1 );
			putchar( 'X' );
			locate( 10, 11 );
			printf( " GAME OVER " );
			return;
		}

		mVSX[ py ][ px ] = 1;

		if( px == mFoodX && py == mFoodY ){
			if( addFood() ){
				return;
			}
		}

		if( mEat ){
			mEat = 0;
		}else{
			locate( lx, ly + 1 );
			putchar( ' ' );

			char	vx = mVSX[ ly ][ lx ];
			char	vy = mVSY[ ly ][ lx ];
			mVSX[ ly ][ lx ] = 0;
			mVSY[ ly ][ lx ] = 0;
			lx += vx;
			ly += vy;
		}

		locate( px, py + 1 );
		putchar( 'O' );

	}
}
